/*
 main program
*/
#include "hmg.ch"
#include "hbqtgui.ch"

#xcommand DEFINE L3WMAIN MENU [ OF <oParent> ]    => WITH OBJECT L3WMNUBAR():New( <oParent> )
#xcommand END L3WMENU                             => :EndMnuMain(); END WITH
#xcommand DEFINE L3WPOPUP <cCaption>              => :AddMnuPopUp( <cCaption> )
#xcommand END L3WPOPUP                            => :EndMnuPopUp()
#xcommand L3WADDMENUITEM <cCaption> [ ACTION <bOnClick> ] [ IMAGE <cImage> ] [ <lChecked : CHECKED> ] [ <lDisabled : DISABLED> ] => :AddMnuItem( <cCaption> , <{bOnClick}> , [<cImage>] , [<.lChecked.>] , [!<.lDisabled.>] )
#xcommand L3WADDSEPARATOR                         => :AddMnuSeparator()

MEMVAR MainForm

FUNCTION main()

   hbQt_ErrorSys()

   ShowMainForm()

RETURN NIL

/*
 Show MainForm
*/
STATIC FUNCTION ShowMainForm()

   PUBLIC MainForm

   DEFINE WINDOW MainForm
      ROW	    0
      COL	    0
      WIDTH	    800
      HEIGHT	 600
      TITLE	    "MainForm - form type WND_MAIN"
      TYPE	    WND_MAIN
      ONINIT	 p000_FrmOnInit()
      FONTSIZE  10

// Hmgx style
      DEFINE L3WMAIN MENU
         FontSize 12
         DEFINE L3WPOPUP "&File"
            L3WADDMENUITEM "item1.1" ACTION MsgInfo( "I'm Happy item1.1")
            L3WADDSEPARATOR
            DEFINE L3WPOPUP "&SubMenu2"
               L3WADDMENUITEM "Subitem2.1" ACTION MsgInfo( "I find Subitem2.1!") IMAGE hb_DirBase()+"open.png"
               DEFINE L3WPOPUP "&SubMenu3"
                  L3WADDMENUITEM "Subitem3.1" ACTION MsgInfo( MainForm:HmgMnu_0:HmgMnu_1:HmgMnu_4:HmgMnu_6:HmgMnu_7:Caption )
               END L3WPOPUP
               L3WADDMENUITEM "Subitem2.2" ACTION MsgInfo( "I find Subitem2.2!") DISABLED
               L3WADDSEPARATOR
               L3WADDMENUITEM "Subitem2.3" ACTION MsgInfo( "I find Subitem2.3!")
            END L3WPOPUP
            L3WADDMENUITEM "item1.2" ACTION MsgInfo( "I'm Happy item1.2")
            L3WADDMENUITEM "Close" ACTION CloseForm() IMAGE hb_DirBase()+"new.png"
         END L3WPOPUP
      END L3WMENU

// OOP style
//      WITH OBJECT L3WMNUBAR():New()
//         :FontSize := 12
//         :AddMnuPopUp( "&File" )
//            :AddMnuItem( "item1.1", {|| MsgInfo( "I'm Happy item1.1") } )
//            :AddMnuSeparator()
//            :AddMnuPopUp( "&SubMenu2" )
//               :AddMnuItem( "Subitem2.1", {|| MsgInfo( "I find Subitem2.1!") }, hb_DirBase()+"open.png" )
//               :AddMnuPopUp( "&SubMenu3" )
//                :AddMnuItem( "Subitem3.1", {|| MsgInfo( "I find Subitem3.1!") } )
//                  :AddMnuItem( "Subitem3.1", {|| MsgInfo( MainForm:HmgMnu_0:HmgMnu_1:HmgMnu_4:HmgMnu_6:HmgMnu_7:Caption ) } )
//               :EndMnuPopUp()
//               :AddMnuItem( "Subitem2.2", {|| MsgInfo( "I find Subitem2.2!") }, NIL, NIL, .F. )
//               :AddMnuSeparator()
//               :AddMnuItem( "Subitem2.3", {|| MsgInfo( "I find Subitem2.3!") } )
//            :EndMnuPopUp()
//            :AddMnuItem( "item1.2", {|| MsgInfo( "I'm Happy item1.2") } )
//            :AddMnuItem( "Close", {|| CloseForm() }, hb_DirBase()+"new.png" )
//         :EndMnuPopUp()
//         :EndMnuMain()
//      END WIDTH

      DEFINE BUTTON Btn1
         ROW	  40
         COL	  40
         WIDTH   200
         CAPTION "Click to close this form"
         ONCLICK Btn1_OnClick()
      END BUTTON

   END WINDOW

   ACTIVATE WINDOW MainForm

RETURN NIL

/*
 MainForm OnInit event
*/
STATIC FUNCTION p000_FrmOnInit()

   MainForm:Center()

RETURN NIL

/*
 MainForm Btn1 OnClick event
*/
STATIC FUNCTION Btn1_OnClick()

   MainForm:Release()

RETURN NIL

/*
 CloseForm
*/
STATIC FUNCTION CloseForm()

   MainForm:Release()

RETURN NIL

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> new class for menu <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< */
#include "hbclass.ch"
#include "common.ch"

#define MNU_QBAR        0
#define MNU_QACT        1
#define MNU_QMNU        2
#define MNU_QSEP        3
/*================================================================
 L3WMNU class
 ================================================================*/
CLASS L3WMNU FROM CONTROL, WINDOW

// shared data
   CLASS VAR lMainMenu                            INIT .F.      SHARED      // need this to know when start a new barmenu
   CLASS VAR nMnuObjCounter                       INIT 0        SHARED      // simple counter, used to create internal varname (eg mnuvar_1, mnuvar_2, etc.)
   CLASS VAR aPopUpMenu                           INIT {}       SHARED      // to store popup men level, used to go forward and backward and retrieve parent
   CLASS VAR nPopUpCounter                        INIT 0        SHARED      // counter for aPopUpMenu
   CLASS VAR oCurrMnuParent                       INIT NIL      SHARED      // current popup menu parent for item or new popup
   CLASS VAR oSuMnuParent                         INIT NIL      SHARED      // super parent: mainmenu it's always the same

// internal data
   DATA bAction                                   INIT NIL      PROTECTED
   DATA cCaption                                  INIT NIL      PROTECTED
   DATA aChilds                                   INIT {}       PROTECTED
   DATA lChecked                                  INIT NIL      PROTECTED
   DATA lEnabled                                  INIT NIL      PROTECTED
   DATA cImage                                    INIT NIL      PROTECTED
   DATA nMnuType                                  INIT NIL      PROTECTED
   DATA cName                                     INIT NIL      PROTECTED
   DATA cTitle                                    INIT NIL      PROTECTED
   DATA lVisible                                  INIT NIL      PROTECTED

// Methods
   METHOD New
   METHOD Create

// Properties
   METHOD Action                                  SETGET
   METHOD Caption                                 SETGET
   METHOD Checked                                 SETGET
   METHOD ChildList                               SETGET
   METHOD Enabled                                 SETGET
   METHOD Image                                   SETGET
   METHOD MnuType                                 SETGET
   METHOD Title                                   SETGET
   METHOD Visible                                 SETGET

ENDCLASS

/*................................................................
 Methods - section
 ................................................................*/

/*---------------------------------------------------------------
 New
 ---------------------------------------------------------------*/
METHOD L3WMNU:New( cName )

   ::cName  := cName

RETURN Self

/*---------------------------------------------------------------
 Create
 ---------------------------------------------------------------*/
METHOD L3WMNU:Create()

   LOCAL nX

   ::lCreated  := .T.

   IF ::nMnuType == MNU_QBAR
      ::oMainMenu := ::oSuMnuParent
      ::oQtObject := QMenuBar( ::oParent:oQtObject )
      ::oFont := ::oParent:oQtObject:Font()
      IF VALTYPE( ::nFontSize )  != 'U'; Self:FontSize      := ::nFontSize  ; ENDIF
      IF VALTYPE( ::cFontName )  != 'U'; Self:FontName      := ::cFontName  ; ENDIF
      IF VALTYPE( ::nFontSize )  != 'U'; Self:FontSize      := ::nFontSize  ; ENDIF
      IF VALTYPE( ::lBold )      != 'U'; Self:FontBold      := ::lBold      ; ENDIF
      IF VALTYPE( ::lItalic )    != 'U'; Self:FontItalic    := ::lItalic    ; ENDIF
      IF VALTYPE( ::lUnderline ) != 'U'; Self:FontUnderline := ::lUnderline ; ENDIF
      IF VALTYPE( ::lStrikeout ) != 'U'; Self:FontStrikeOut := ::lStrikeout ; ENDIF
   ENDIF
   IF ::nMnuType == MNU_QMNU
      ::oQtObject := QMenu( ::oParent:oQtObject )
      ::oFont := ::oParent:oQtObject:Font()
      ::oQtObject:setTitle( ::cTitle )
      IF hb_IsChar( ::cImage ) == .T.
         ::oQtObject:setIcon( ::cImage )
      ENDIF
   ENDIF
   IF ::nMnuType == MNU_QACT
      ::oQtObject := QAction( ::oParent:oQtObject )
      ::oFont := ::oParent:oQtObject:Font()
      ::oQtObject:setText( ::cCaption )
      IF hb_IsChar( ::cImage ) == .T.
         ::oQtObject:setIcon( ::cImage )
      ENDIF
      IF hb_IsLogical( ::lChecked ) == .T.
         ::oQtObject:setCheckable( .T. )
         ::oQtObject:setChecked( ::lChecked )
      ENDIF
      IF hb_IsLogical( ::lEnabled ) == .T.
         ::oQtObject:setEnabled( ::lEnabled )
      ENDIF
      IF hb_IsLogical( ::lVisible ) == .T.
         ::oQtObject:setVisible( ::lVisible )
      ENDIF
      IF hb_IsBlock( ::bAction ) == .T.
         ::oQtObject:connect( "triggered(bool)", ::bAction )
      ENDIF
   ENDIF
   IF ::nMnuType == MNU_QSEP
      ::oQtObject := QAction( ::oParent:oQtObject )
      ::oFont := ::oParent:oQtObject:Font()
      ::oQtObject:setText( ::cCaption )
      ::oQtObject:setSeparator( .T. )
   ENDIF

   ::oQTObject:SetFont( ::oFont )

   FOR nX := 1 TO LEN( ::aChilds )
      IF __objHasMethod( ::aChilds[nX], "create" ) == .T.
         ::aChilds[nX]:Create()
      ENDIF
   NEXT nX

   IF ::nMnuType == MNU_QBAR
      ::oParent:oQtObject:setMenuBar( ::oQtObject )
   ENDIF
   IF ::nMnuType == MNU_QMNU
      ::oParent:oQtObject:addmenu( ::oQtObject )
   ENDIF
   IF ::nMnuType == MNU_QACT
      ::oParent:oQtObject:addaction( ::oQtObject )
   ENDIF
   IF ::nMnuType == MNU_QSEP
      ::oParent:oQtObject:addaction( ::oQtObject )
   ENDIF

RETURN NIL

/*................................................................
 Properties - section
 ................................................................*/

/*---------------------------------------------------------------
 Action
 ---------------------------------------------------------------*/
METHOD L3WMNU:Action( bArg1 )

   IF PCOUNT() == 0
      RETURN ::bAction
   ELSEIF hb_IsBlock( bArg1 ) == .T.
      ::bAction := bArg1
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 Caption
 ---------------------------------------------------------------*/
METHOD L3WMNU:Caption( cArg1 )

   IF PCOUNT() == 0
      RETURN ::cCaption
   ELSEIF hb_IsChar( cArg1 ) == .T.
      ::cCaption := cArg1
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 Checked
 ---------------------------------------------------------------*/
METHOD L3WMNU:Checked( lArg1 )

   IF PCOUNT() == 0
      RETURN ::lChecked
   ELSEIF hb_IsLogical( lArg1 ) == .T.
      ::lChecked := lArg1
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 ChildList
 ---------------------------------------------------------------*/
METHOD L3WMNU:ChildList( aArg1 )

   IF PCOUNT() == 0
      RETURN ::aChilds
   ELSEIF hb_IsArray( aArg1 )
      ::aChilds := aArg1
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 Enabled
 ---------------------------------------------------------------*/
METHOD L3WMNU:Enabled( lArg1 )

   IF PCOUNT() == 0
      RETURN ::lEnabled
   ELSEIF hb_IsLogical( lArg1 ) == .T.
      ::lEnabled := lArg1
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 Image
 ---------------------------------------------------------------*/
METHOD L3WMNU:Image( cArg1 )

   IF PCOUNT() == 0
      RETURN ::cImage
   ELSEIF hb_IsChar( cArg1 ) == .T.
      ::cImage := cArg1
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 MnuType
 ---------------------------------------------------------------*/
METHOD L3WMNU:MnuType( nArg1 )

   IF PCOUNT() == 0
      RETURN ::cImage
   ELSEIF hb_IsNumeric( nArg1 ) == .T.
      ::nMnuType := nArg1
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 Title
 ---------------------------------------------------------------*/
METHOD L3WMNU:Title( cArg1 )

   IF PCOUNT() == 0
      RETURN ::cTitle
   ELSEIF hb_IsChar( cArg1 ) == .T.
      ::cTitle := cArg1
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 Visible
 ---------------------------------------------------------------*/
METHOD L3WMNU:Visible( lArg1 )

   IF PCOUNT() == 0
      RETURN ::lVisible
   ELSEIF hb_IsLogical( lArg1 ) == .T.
      ::lVisible := lArg1
   ENDIF

RETURN NIL

/*================================================================
 L3WMNUBAR class
 ================================================================*/
CLASS L3WMNUBAR FROM L3WMNU

// methods
   METHOD New
   METHOD AddMnuItem
   METHOD AddMnuPopUp
   METHOD AddMnuSeparator
   METHOD EndMnuMain
   METHOD EndMnuPopUp

ENDCLASS

/*................................................................
 Methods - section
 ................................................................*/

/*---------------------------------------------------------------
 New
 ---------------------------------------------------------------*/
METHOD L3WMNUBAR:New( oParent )

   IF ::lMainMenu == .F.
      ::lMainMenu      := .T.
      ::nMnuObjCounter := 0
      ::aChilds        := {}
      ::aPopUpMenu     := {}
      ::nPopUpCounter  := 0
      ::cName          := "HMGMNU_" + hb_NtoS( ::nMnuObjCounter )
      ::oSuMnuParent   := Self
      ::oCurrMnuParent := Self
      ::nMnuType       := MNU_QBAR
      ::oParent := IF( hb_IsObject( oParent ), oParent, IF( hb_IsObject( ::oContainer ), ::oContainer, ::oDefaultParent ) )
      ::oParent        := ::oDefaultParent
// add HmgObject to its parent
      AADD( ::oParent:aControls , Self )
      ::oParent:AddData( ::cName , Self )
   ENDIF

RETURN Self

/*---------------------------------------------------------------
 AddMnuItem
 ---------------------------------------------------------------*/
METHOD L3WMNUBAR:AddMnuItem( cCaption, bAction, cImage, lChecked, lEnabled, lVisible )

   LOCAL oNewObject, cNewObjectName, aChilds

// create an internal varname
   ::nMnuObjCounter++
   cNewObjectName := "HMGMNU_" + hb_NtoS( ::nMnuObjCounter )

   cCaption := IF( hb_IsChar( cCaption ) == .T., cCaption, cNewObjectName )

// create a new object with internal name
   oNewObject := L3WMNU():New( cNewObjectName )

// add created object to its parent
   __objAddData( ::oCurrMnuParent, cNewObjectName )
   ::oCurrMnuParent:&cNewObjectName := oNewObject
   aChilds := ::oCurrMnuParent:ChildList
   AADD( aChilds, oNewObject )
   ::oCurrMnuParent:ChildList := aChilds

// setup HMG object
   ::oCurrMnuParent:&cNewObjectName:MnuType := MNU_QACT
   ::oCurrMnuParent:&cNewObjectName:Parent  := ::oCurrMnuParent
   ::oCurrMnuParent:&cNewObjectName:Caption := cCaption
   ::oCurrMnuParent:&cNewObjectName:Action  := bAction
   ::oCurrMnuParent:&cNewObjectName:Image   := cImage
   ::oCurrMnuParent:&cNewObjectName:Checked := lChecked
   ::oCurrMnuParent:&cNewObjectName:Enabled := lEnabled
   ::oCurrMnuParent:&cNewObjectName:Visible := lVisible

RETURN NIL

/*---------------------------------------------------------------
 AddMnuPopUp
 ---------------------------------------------------------------*/
METHOD L3WMNUBAR:AddMnuPopUp( cTitle, cImage )

   LOCAL oNewObject, cNewObjectName, aChilds

// create an internal varname
   ::nMnuObjCounter++
   cNewObjectName := "HMGMNU_" + hb_NtoS( ::nMnuObjCounter )

   cTitle := IF( hb_IsChar( cTitle ) == .T., cTitle, cNewObjectName )

// create a new object with internal name
   oNewObject := L3WMNU():New( cNewObjectName )

// add created object to its parent
   __objAddData( ::oCurrMnuParent, cNewObjectName )
   ::oCurrMnuParent:&cNewObjectName := oNewObject
   aChilds := ::oCurrMnuParent:ChildList
   AADD( aChilds, oNewObject )
   ::oCurrMnuParent:ChildList := aChilds

// setup HMG object
   ::oCurrMnuParent:&cNewObjectName:MnuType := MNU_QMNU
   ::oCurrMnuParent:&cNewObjectName:Parent  := ::oCurrMnuParent
   ::oCurrMnuParent:&cNewObjectName:Title   := cTitle
   ::oCurrMnuParent:&cNewObjectName:Image   := cImage

// create a new level
   ::oCurrMnuParent := ::oCurrMnuParent:&cNewObjectName
   ::nPopUpCounter++
   AADD( ::aPopUpMenu, ::oCurrMnuParent )

RETURN NIL

/*---------------------------------------------------------------
 AddMnuSeparator
 ---------------------------------------------------------------*/
METHOD L3WMNUBAR:AddMnuSeparator( cCaption )

   LOCAL oNewObject, cNewObjectName, aChilds

// create an internal varname
   ::nMnuObjCounter++
   cNewObjectName := "HMGMNU_" + hb_NtoS( ::nMnuObjCounter )

   cCaption := IF( hb_IsChar( cCaption ) == .T., cCaption, cNewObjectName )

// create a new object with internal name
   oNewObject := L3WMNU():New( cNewObjectName )

// add created object to its parent
   __objAddData( ::oCurrMnuParent, cNewObjectName )
   ::oCurrMnuParent:&cNewObjectName := oNewObject
   aChilds := ::oCurrMnuParent:ChildList
   AADD( aChilds, oNewObject )
   ::oCurrMnuParent:ChildList := aChilds

// setup HMG object
   ::oCurrMnuParent:&cNewObjectName:MnuType := MNU_QSEP
   ::oCurrMnuParent:&cNewObjectName:Parent  := ::oCurrMnuParent
   ::oCurrMnuParent:&cNewObjectName:Caption := cCaption

RETURN NIL

/*---------------------------------------------------------------
 EndMnuMain
 ---------------------------------------------------------------*/
METHOD L3WMNUBAR:EndMnuMain()

   ::oCurrMnuParent := ::oSuMnuParent
   ::lMainMenu      := .F.

RETURN NIL

/*---------------------------------------------------------------
 EndMnuPopUp
 ---------------------------------------------------------------*/
METHOD L3WMNUBAR:EndMnuPopUp()

   ::nPopUpCounter--
   ::nPopUpCounter := IF( ::nPopUpCounter < 0, 0, ::nPopUpCounter )
   ::oCurrMnuParent := IF( ::nPopUpCounter > 0, ::aPopUpMenu[::nPopUpCounter], ::oSuMnuParent )

RETURN NIL
